function aRng=aRange(varargin)
%aRange class constructor
% constructs an object charactering a range(closed intervals) of values
%   inputs
%   ()  -- range corresponding to a (0,1)
%   (a)  -- range corresponding to a (a,a)
%   (a,b)  -- range corresponding to (a,b)
%    takes bnkVal's which allow for 'useDefault' in addition to double
%defaultRange=[bndVal(0) bndVal(1)];
defaultRangeL=unSpec;
defaultRangeH=unSpec;
switch nargin
 case (0)
  aRng.lowerPt=defaultRangeL;
  aRng.upperPt=defaultRangeH;
  aRng=class(aRng,'aRange');
 case (1)
  arg1=varargin{1};
  if(isa(arg1,'aRange'))
    aRng=arg1;
  elseif(oneByTwo(arg1))
    if(and(isa(arg1(1),'double'),isa(arg1(2),'double')))
      if(arg1(2)<arg1(1))
        error('aRange constructor: lower bound exceeds upper bound');
      end
    end
    aRng.lowerPt=bndVal(arg1(1));
    aRng.upperPt=bndVal(arg1(2));
    aRng=class(aRng,'aRange');
  elseif(oneByTwo(arg1'))
    aRng=aRange(arg1');
  elseif(oneByOne(arg1))
    aRng=aRange([bndVal(arg1) bndVal(arg1)]);
    %aRng=class(aRng,'aRange');
    %elseif(scalarDoubleQ(arg1))
    %aRng.lowerPt=bndVal(arg1);
    %aRng.upperPt=bndVal(arg1);
    %aRng=class(aRng,'aRange');
  else
    error('aRange constructor: one arg call failing');
  end
 case (2)
  arg1=varargin{1};arg2=varargin{2};
  if(and(oneByOne(arg1),oneByOne(arg2)))
    if(and(isa(arg1,'double'),isa(arg2,'double')))
      if(arg2<arg1)
        error('aRange constructor: lower bound exceeds upper bound');
      end
    end
    aRng.lowerPt=bndVal(arg1(1));
    aRng.upperPt=bndVal(arg2(1));
    aRng=class(aRng,'aRange');
  else 
    error('varBounds constructor failing with two inappropriate args')
  end
 otherwise
  error('varBounds constructor failing with wrong number of args')
end




function res=scalarDoubleQ(arg)
res=0
try
  and(all(size(arg)==[1 1]),isa(arg,'double'))
  res=1
catch
  warning('scarlarDoubleQ: failing on arg')
  arg
end
