function theBnds=genBounds(varargin)
%function theBnds=genBounds(anRSpec) or theBnds=genBounds(modName,anRSpec)
%generate bounds matrix for "global search" algorithm (findSteadyState)
switch nargin
case 1
	 anRSpec=varargin{1};
case 2
	 eval(['dynare ' varargin{1}])
	 anRSpec=varargin{2};
otherwise
error('genBounds: too many args')
end

try
eNames=getDynareEndo_Names;
catch
error('genBounds: no active dynare model')
end
numVars=size(eNames,1);
vSpecs=getTheVarSpecs(anRSpec);
numSpecs=size(vSpecs,2);

theBnds=setDefaultBounds(anRSpec);

%getVNameRegExp
%getTheRange   
for ii=1:numSpecs
%disp('new ii');disp(getVNameRegExp(vSpecs(ii)));
theRegExp=getVNameRegExp(vSpecs(ii));
lVal=getLowerVal(getTheRange(vSpecs(ii)));
uVal=getUpperVal(getTheRange(vSpecs(ii)));
for jj=1:numVars
theMatch=regexp(eNames(jj,:),theRegExp,'match');
if(length(theMatch)>0)
if(strcmp(deblank(theMatch{1}),deblank(eNames(jj,:))))
disp([theMatch '<<< >>>' deblank(eNames(jj,:))])
theBnds(jj,1)=updateIfSpec(theBnds(jj,1),lVal);
theBnds(jj,2)=updateIfSpec(theBnds(jj,2),uVal);
end
end
%regexp(getVNameRegExp(vSpecs(ii)),eNames(jj),'tokens')
%regexp(getVNameRegExp(vSpecs(ii)),eNames(jj),'tokenExtents')
%regexp(getVNameRegExp(vSpecs(ii)),eNames(jj),'names')
end
end
try
disp(sprintf('active dynare model=%s',getDynareModelName))
catch
error('no active dynare model')
end
showBnds(theBnds,eNames)

%theLoc=find(strcmp(M_.endo_names,{theSpec{ii}}));
%if(theLoc)
%disp(sprintf('setting %s ... ',theSpec{ii,1}));
%theBnds(theLoc,:)=[theSpec{ii,2},theSpec{ii,3}];
%end
%end
%else
%disp(['did not find:'  M_.fname '_varBounds.m'])
%end


function theBnds=setDefaultBounds(anRSpec)
%anRSpec
theDefaultVals=[0 1];
eNames=getDynareEndo_Names;
numVars=size(eNames,1);
theBnds=zeros(numVars,2);
theDefaultRng=getDefaultRanges(anRSpec);
if(~isa(getLowerVal(theDefaultRng),'unSpec'))
theDefaultVals(1)=getLowerVal(theDefaultRng);
end
if(~isa(getUpperVal(theDefaultRng),'unSpec'))
theDefaultVals(2)=getUpperVal(theDefaultRng);
end
for(ii=1:numVars)
theBnds(ii,:)=theDefaultVals;
end

function theRes=updateIfSpec(oldVal,possibleNewVal)
if(isa(possibleNewVal,'unSpec'))
theRes=oldVal;
else
theRes=possibleNewVal;
end



function showBnds(theBnds,eNames)
numRows=size(theBnds,1);
display('the bounds');
for ii=1:numRows
disp(sprintf('%s:  %d    %d',eNames(ii,:),theBnds(ii,1),theBnds(ii,2)));
end
