function theRegion=regionSpec(varargin)
%regionSpec object constructor
% regionSpec no args generates default region--vars on interval [0,1].
% regionSpec iterates sequential through its arguments left to right.
% regionSpec(varRange) changes region for specific variable
%  type help varRange for more info
% regionSpec(aRange) changes the global "nonspecified" default region
%  (ie regionSpec([-3,5]) or regionSpec(aRange(-3,5)))
%$Id: regionSpec.m,v 1.5 2007/04/10 18:10:00 m1gsa00 Exp $
theRegion.defaultRanges=aRange;
theRegion.theVarSpecs=noVarRanges;
newNargin=twoDoublesQ(varargin,nargin);
switch newNargin
case -1
theRegion=regionSpec([varargin{1} varargin{2}]);
case 0
theRegion=class(theRegion,'regionSpec');
otherwise
for(ii=1:nargin)
argii=varargin{ii};
switch class(argii)
case 'varRange'
if(isa(theRegion.theVarSpecs,'noVarRanges'))
theRegion.theVarSpecs=argii;
else
theRegion.theVarSpecs=[theRegion.theVarSpecs argii];
end
case 'noVarRanges'
%theRegion.theVarSpecs=[theRegion.theVarSpecs argii];
case 'aRange'
theRegion.defaultRanges=aRange(argii);
case 'double'
theRegion.defaultRanges=aRange(argii);
case 'bndVal'
theRegion.defaultRanges=aRange(argii);
case 'regionSpec'
theRegion.defaultRanges=getDefaultRanges(argii);
theRegion.theVarSpecs=getTheVarSpecs(argii);
otherwise
error('regionSpec constructor: do not know how to handle arg');
end
end
theRegion=class(theRegion,'regionSpec');
end


function newNargin=twoDoublesQ(oldVarargin,oldNargin)
if(oldNargin==2)
if(and(isa(oldVarargin{1},'double'),isa(oldVarargin{1},'double')))
newNargin=-1;
else
newNargin=oldNargin;
end
else
newNargin=oldNargin;
end
