function vRng=varRange(varargin)
%varRange specify a range of values for a specific variable
%varRange no args creates a spec that matches any variable name and
%varRange(aRegExp), creates a spec that a associates
% a [0 1] acceptable range with each variable matching aRegExp.
% (ie varRange('XX_.*'))
%varRange(aRegExp,aRange), creates a spec that a associates
% aRange as the acceptable range for each variable matching aRegExp.
% (ie varRange('XX_.*',[-1,1]),varRange('XX_.*',aRange(-1,1)))
%varRange(aRegExp,lower,upper), creates a spec that a associates
% [lower,upper] as the acceptable range for each variable matching aRegExp.
% (ie varRange('XX_.*',-1,1)
% matches regular expression
% type help regexp for more information on regular expressions
%  
%$Id: varRange.m,v 1.4 2007/04/10 18:10:00 m1gsa00 Exp $
vRng.vNameRegExp='.*';
vRng.theRange=aRange;
switch nargin
case 0
vRng=class(vRng,'varRange');
case 1
arg1=varargin{1};
if(isa(arg1,'char'))
vRng.vNameRegExp=arg1;
else
error('varRange constructor: single arg must be string regexp');
end
vRng=class(vRng,'varRange');
case 2
arg1=varargin{1};
arg2=varargin{2};
if(isa(arg1,'char'))
vRng.vNameRegExp=arg1;
else
error('varRange constructor: first arg must be string regexp');
end
vRng.theRange=aRange(arg2);
vRng=class(vRng,'varRange');
case 3
arg1=varargin{1};
arg2=varargin{2};
arg3=varargin{3};
if(isa(arg1,'char'))
vRng.vNameRegExp=arg1;
else
error('varRange constructor: first arg must be string regexp');
end
vRng.theRange=aRange(arg2,arg3);
vRng=class(vRng,'varRange');
otherwise
error('varRange constructor: to many args');
end
