function res=setSomeValues(varargin)
% generate a regionSpec representing
% global seach region variable specifications
% all args optional(order determines scope of assignments)
% input any number of the following
%    variable name (or regexp representing collection  of variable names)  
%          a scalarnumeric
%    a scalar value, or range
%    a cell array consisting of (names,  values and other cell arrays)
% output
%    a regionSpec object characterizing a global search region
% examples:
%    setSomeValues('xxx')   -> generates a rangeSpec with xxx at zero
%    setSomeValues(99,'xxx')   -> generates a rangeSpec with xxx at 99
%    setSomeValues([1 5],'xxx')   
%    setSomeValues('xxx',[1 5],'yyy','zzz')   -> 
%          generates a rangeSpec with xxx at 0 and yyy and zzz  between 1,5
%    setSomeValues(99,'xxx',{33,'yyy','zzz'},'lll') -> 
%          generates a rangeSpec with xxx and lll at 99, yyy and zzz at 33
%$Id:$
res=regionSpec;
theValue=0;%default value to use
for ii=1:nargin
argii=varargin{ii};
switch class(argii)
case 'double'
theValue=argii;
case 'aRange'
theValue=argii;
case 'char'
try
incRes=feval(@varRange,argii,theValue);
res=res+incRes;
catch
error('setSomeValues: not very clever cell arrays of  regexps')
end
case 'cell'
res=res+setSomeValues(argii{:});
otherwise
error('setSomeValues: confused about what to do')
end
end
